//
// NeoMagicModes.c
// NeoMagic Display Driver
//
// Copyright (c) 2004 David Lazaro Saz.
// All rights reserved.
//

#include "NeoMagicModes.h"

const IODisplayInfo NeoMagicModeTable[] = {
    /* NeoMagic 1024 x 768 x 15 @ 60 Hz. */
    {
        1024, 768, 1024, 2048, 60, 0,
	IO_15BitsPerPixel, IO_RGBColorSpace, "-RRRRRGGGGGBBBBB",
	IO_DISPLAY_HAS_TRANSFER_TABLE, 0
    },
    /* NeoMagic 800 x 600 x 15 @ 60 Hz. */
    {
        800, 600, 800, 1600, 60, 0,
	IO_15BitsPerPixel, IO_RGBColorSpace, "-RRRRRGGGGGBBBBB",
	IO_DISPLAY_HAS_TRANSFER_TABLE, 0
    },
    /* NeoMagic 800 x 600 x 24 @ 60 Hz. */
    {
        800, 600, 800, 2400, 60, 0,
	IO_24BitsPerPixel, IO_RGBColorSpace,
	"--------RRRRRRRRGGGGGGGGBBBBBBBB",
	IO_DISPLAY_HAS_TRANSFER_TABLE, 0
    },
    /* NeoMagic 800 x 480 x 15 @ 60 Hz. */
    {
        800, 480, 800, 1600, 60, 0,
        IO_15BitsPerPixel, IO_RGBColorSpace, "-RRRRRGGGGGBBBBB",
        IO_DISPLAY_HAS_TRANSFER_TABLE, 0
    },
    /* NeoMagic 640 x 480 x 15 @ 60 Hz. */
    {
        640, 480, 640, 1280, 60, 0,
        IO_15BitsPerPixel, IO_RGBColorSpace, "-RRRRRGGGGGBBBBB",
        IO_DISPLAY_HAS_TRANSFER_TABLE, 0
    }
};

const VGAMode NeoMagicCRTCModeTable[] = {
    /* NeoMagic 1024 x 768 x 15 @ 60 Hz. */
    // 	Modeline "1024x768_60" 65 1024 1048 1184 1344 768 771 777 806 -HSync -VSync
    //  ModeLine "1024x768" 65.00 1024 1048 1184 1344 768 771 777 806 -HSync -VSync
    
    {
        65000, -1, 15, 0x36,
	1024, 1024, 1344, 1048, 1184, 1344, 0,
	768, 768, 806, 771, 777, 806, 1,
	VGAModeNHSync | VGAModeNVSync
    },
    /* NeoMagic 800 x 600 x 15 @ 60 Hz. */
    {
        40000, -1, 15, 0x33,
	800, 800, 1056, 840, 968, 1056, 0,
	600, 600, 628, 601, 605, 628, 1,
	VGAModePHSync | VGAModePVSync
    },
    /* NeoMagic 800 x 600 x 24 @ 60 Hz. */
    
    //pclk hdisp hsyncstart hsyncend htotal vdisp vsyncstart vsyncend vtotal [flags]
    
    // 	Modeline "800x600_60.32" 40 800 840 968 1056 600 601 605 628 +HSync +VSync
    
    //Not:    Modeline "800x600" 40 800 856 1040 1056 600 600 626 628 +hsync +vsync
    {
        40000, -1, 24, 0x35,
	800, 800, 1056, 840, 968, 1056, 0,
	600, 600, 628, 601, 605, 628, 1,
	VGAModePHSync | VGAModePVSync
    },
    /* NeoMagic 800 x 480 x 15 @ 60 Hz. */
    //Modeline "800x480" 40 800 864 928 1088 480 481 484 509 +hsync
    {
        25000, -1, 15, 0x33,
        800, 800, 1056, 840, 968, 1056, 0,
        480, 480, 508, 481, 485, 508, 1,
        VGAModePHSync | VGAModePVSync
    },
    /* NeoMagic 640 x 480 x 15 @ 60 Hz. */
    {
        25175, -1, 15, 0x30,
        640, 640, 800, 648, 744, 800, 0,
        480, 480, 525, 482, 484, 525, 1,
        VGAModeNHSync | VGAModeNVSync
    }
};

const int NeoMagicModeCount = sizeof(NeoMagicModeTable) /
                              sizeof(NeoMagicModeTable[0]);

const int LibrettoDisplayModeIndex = 3; //Index of 800x480 mode
