//
// PCI.c
// PCI Bus Helper Functions
//
// Copyright (c) 2004 David Lazaro Saz.
// All rights reserved.
//

#include "PCI.h"

#import <driverkit/generalFuncs.h>


void configSpaceLog(IOPCIConfigSpace *configSpace, const char *moduleName)
{
    //int i;
    
    IOLog("%s: PCI configuration space dump:\n", moduleName);
    IOLog("%s:     Vendor ID: 0x%04x\n", moduleName, configSpace->VendorID);
    IOLog("%s:     Device ID: 0x%04x\n", moduleName, configSpace->DeviceID);
    IOLog("%s:     Command: 0x%04x\n", moduleName, configSpace->Command);
    IOLog("%s:     Status: 0x%04x\n", moduleName, configSpace->Status);
    IOLog("%s:     Revision ID: 0x%02lx\n", moduleName, configSpace->RevisionID);
    IOLog("%s:     Class code: 0x%06x\n", moduleName, configSpace->ClassCode);
    IOLog("%s:     Cache line size: 0x%02x\n", moduleName, configSpace->CacheLineSize);
    IOLog("%s:     Latency timer: 0x%02x\n", moduleName, configSpace->LatencyTimer);
    IOLog("%s:     Header type: 0x%02x\n", moduleName, configSpace->HeaderType);
    IOLog("%s:     Built-in self-test: 0x%02x\n", moduleName, configSpace->BuiltInSelfTest);
    IOLog("%s:     Base address (0): 0x%08lx\n", moduleName, configSpace->BaseAddress[0]);
    IOLog("%s:     Base address (1): 0x%08lx\n", moduleName, configSpace->BaseAddress[1]);
    IOLog("%s:     Base address (2): 0x%08lx\n", moduleName, configSpace->BaseAddress[2]);
    IOLog("%s:     Base address (3): 0x%08lx\n", moduleName, configSpace->BaseAddress[3]);
    IOLog("%s:     Base address (4): 0x%08lx\n", moduleName, configSpace->BaseAddress[4]);
    IOLog("%s:     Base address (5): 0x%08lx\n", moduleName, configSpace->BaseAddress[5]);
    IOLog("%s:     Reserved 1: 0x%08lx\n", moduleName, configSpace->reserved1);
    IOLog("%s:     Reserved 2: 0x%08lx\n", moduleName, configSpace->reserved2);
    IOLog("%s:     ROM base address: 0x%08lx\n", moduleName, configSpace->ROMBaseAddress);
    IOLog("%s:     Reserved 3: 0x%08lx\n", moduleName, configSpace->reserved3);
    IOLog("%s:     Reserved 4: 0x%08lx\n", moduleName, configSpace->reserved4);
    IOLog("%s:     Interrupt line: 0x%02x\n", moduleName, configSpace->InterruptLine);
    IOLog("%s:     Interrupt pin: 0x%02x\n", moduleName, configSpace->InterruptPin);
    IOLog("%s:     Min. grant: 0x%02x\n", moduleName, configSpace->InterruptLine);    
}
